"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class TransactionStatusChange(ProtocolElement):
    """
    Keeps track of a transaction status change
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "timestamp",
        "to",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_2 import cva as cva_1_3_0

        return {
            "to": cva_1_3_0.TransactionStatus,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_2 import cva as cva_1_3_0

        return {
            "org.gel.models.cva.avro.TransactionStatus": cva_1_3_0.TransactionStatus,
            "org.gel.models.cva.avro.TransactionStatusChange": cva_1_3_0.TransactionStatusChange,
        }

    __slots__ = [
        "timestamp",
        "to",
        "cvaVersion",
        "errorMessage",
        "message",
        "stackTrace",
    ]

    def __init__(
        self,
        timestamp,
        to,
        cvaVersion=None,
        errorMessage=None,
        message=None,
        stackTrace=None,
        validate=None,
        **kwargs
    ):
        """Initialise the cva_1_3_0.TransactionStatusChange model.

        :param timestamp:
            A timestamp with the status change
        :type timestamp: str
        :param to:
            The new transaction status
        :type to: TransactionStatus
        :param cvaVersion:
            The CVA version that processed the transaction
        :type cvaVersion: None | str
        :param errorMessage:
            An error message in case the transaction ingestion failed
        :type errorMessage: None | str
        :param message:
            A message
        :type message: None | str
        :param stackTrace:
            The stracktrace in case the transaction ingestion failed
        :type stackTrace: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.3.0"
